LVAR roomname   
LVAR roomdb
LVAR exitname
LVAR backexit
: ok_name? ( [ s -- b ]  -  Is name s valid? )
  dup "*" stringpfx not 
  over "$" stringpfx not and
  over "#" stringpfx not and
  over "&" instr not and
  over "=" instr not and
  over "|" instr not and
  over "!" stringpfx not and
  over "me" stringcmp and
  over "here" stringcmp and
  over "home" stringcmp and
  swap pop
;
 
: store-names ( [ s --  ]  -  Parse argument string s, store names in lvars ) 
  "=" .split swap roomname !
  "," .split backexit ! exitname !
;
 
: show-help ( [  --  ]  -  Display help screen )
  "Usage: "
  trig name ";" .split pop
  " <room name>[=exit into room][,backlink]" 
  strcat strcat .tell
;
 
: do-creation ( [  --  ]  -  Create room and exits )
  me @ location location dup ok? not if pop #0 then
  roomname @
  newroom roomdb !
  roomname @ " created with Room number " strcat
  roomdb @ intostr strcat "." strcat
  .tell
 
  exitname @ if
    me @ location
    exitname @
    newexit
    dup roomdb @ setlink
    "Exit created with number " swap intostr strcat
    " and linked to room " strcat roomname @ strcat "." strcat
    .tell
  then
 
  backexit @ if
    roomdb @
    backexit @
    newexit
    dup me @ location setlink
    "Exit created with number " swap intostr strcat
    " on Room " strcat roomname @ strcat "," strcat .tell
    "and linked to your current location." .tell
  then
;
 
: main
  me @ "B" flag? not if
    "That command is restricted to authorized builders." .tell
    exit
  then
 
  strip
  dup not over "#h" stringpfx or if
    show-help exit
  then
  
  store-names
 
  roomname @ ok_name? dup not if
    "The name \"%s\" is not a valid room name." roomname @ "%s" subst .tell
    exit
  then
  
  exitname @ if
    exitname @ ok_name? not if
      "The name \"%s\" is not a valid exit name." exitname @ "%s" subst .tell
      exit
    then
  then
 
  backexit @ if
    backexit @ ok_name? not if
      "The name \"%s\" is not a valid exit name." backexit @ "%s" subst .tell
      exit
    then
  then
 
  exitname @ backexit @ or if
    me @ dup location owner dbcmp not me @ "w" flag? not and if
      ">> Error. You cannot create exits to/from a room you don't own." .tell
      exit
    then
  then
 
  do-creation
  "Done." .tell
;

