( 
  SUBWAY.MUF     by Gyroplast  10/10/98
  
  This program simulates a vehicle moving from one station to another.
  Whether the vehicle is an airplane, a monorail, or an ordinary subway 
  is of course up to your imagination.
 
  To install it, do the following:
 
    1. Create at least two rooms that will act as a station.
    2. Create at least one room that is used as the vehicle.
    3. Create another room as a cockpit {optional, but recommended}
    4. Create an action on the cockpit, and link it to this program.
       {cockpit recommended so you can lock away the action to prevent abuse}
    5. Run the setup.
    6. Set the TrainEntrance property on each station, as shown in #HELP2
    7. Run #CHECK to test if everything's correctly setup.
    8. Set the optional properties on the stations as needed.
    9. #START the train and have phun!
 
  NOTE:  The train will drive on until you #STOP it, turning when it
         reaches the end of a route!
 
  Warning: This program is OLD. The code is NOT legible, and I don't feel
           like changing this. In fact I don't know how to setup a working
           subway off hand anymore myself. 
           Good luck on setting this baby up..
 
  *** check http://www.gyroplast.com for this and many other programs! ***
  *** This program is distributed under the GPL. Porting and mods      ***
  *** are explicitly allowed as long as this header stays intact, and  ***
  *** the result of any modification is distributed under the GPL.     ***
  *** For a detailed description of the DOs and DONTs, read the GPL at ***
  *** http://www.gyroplast.com/help/gpl.txt   --Thank you--            ***
 
)
$def title "===--  Subway  v1.0    by Gyroplast  --==="
$def exitlist "_TRAIN/exits"   (  List of rooms with exits to the station )
$def speakers "_TRAIN/speaker"   ( Rooms which can hear announcements in the train)
$def routeprop "_TRAIN/stations"  (  subway route  )
$def A_Warning "_TRAIN/ARRIVE/warning"    ( msg before arrival in train  )
$def A_Stop "_TRAIN/ARRIVE/stop"   ( msg when train stops, broadcasted in train  )
$def D_Warning "_TRAIN/DEPART/warning"  (  msg when train is about to start, brdcst in train  )
$def D_Start "_TRAIN/DEPART/start"    ( msg when train starts, brdcst in train  )
$def drivedelay "_TRAIN/drivedelay"   ( time to drive )
$def stopdelay "_TRAIN/stopdelay"   ( time to stop at stations )
$def arrivedelay "_TRAIN/arrivedelay"   ( arrival-warning be displayed x secs before arrival )
$def departdelay "_TRAIN/departdelay"   ( departure-warning will be displayed x secs before departure )
$def trainentrance "_STATION/TrainEntrance"   ( Exitdbref of entrance into the train  )
$def exitname "_TRAIN/EXIT/name"  ( Name of the exit leading to the station )
$def exitfail "_TRAIN/EXIT/fail"   ( Failmessage )
$def exitofail "_TRAIN/EXIT/ofail"   ( Failmessage others see )
$def exitsucc "_TRAIN/EXIT/succ"   ( Succmessage )
$def exitosucc "_TRAIN/EXIT/osucc"   ( Succmessage others see )
lvar newtarget
lvar target
lvar temp
lvar count
lvar ownvar
lvar subwaycar
: repairlist
  "" "#" subst
  " " explode
  BEGIN
  1 - dup count !
  dup not if pop STRIP break then
  pop
  STRIP " " strcat swap strcat
  count @
  REPEAT
;
: owncheck  (d s -- i)
  swap
  ownvar !
  subwaycar @ swap getpropstr 
  " " explode
  BEGIN
  dup count !
  not if 0 exit then
  atoi dbref owner ownvar @ dbcmp not if 1 break then
  count @ 1 -
  REPEAT
  count @ 1 - count !
  BEGIN
  swap
  count @
  1 -
  dup
  dup -1 = if pop pop swap exit then
  not if pop pop break then
  count !
  pop
  REPEAT
;
: swaproute
  subwaycar @
  routeprop getpropstr
  " " explode
  BEGIN
  1 -
  dup not if pop break then
  count !
  " " swap strcat strcat
  count @
  repeat
  subwaycar @
  swap routeprop swap 0 addprop
;
: setup
  "The vehicle can be exited through the following rooms at the moment:" .tell
  subwaycar @ exitlist getpropstr " " strcat .tell
  "Type a single space to keep this, a '.' to abort, or a list of dbrefs seperated with spaces." .tell
  READ
  dup "." stringcmp not if "Setup aborted." .tell exit then
  dup " " stringcmp if 
  repairlist
  subwaycar @ swap exitlist swap 0 addprop
  then
  "Messages inside the train will be broadcasted to the rooms:" .tell
  subwaycar @ speakers getpropstr " " strcat .tell
  "Type a single space to keep this, a '.' to abort, or a list of dbrefs seperated with spaces." .tell
  READ
  dup "." stringcmp not if "Setup aborted." .tell exit then
  dup " " stringcmp if
  repairlist
  subwaycar @ swap speakers swap 0 addprop
  then
  "The train will follow this route at the moment:" .tell
  subwaycar @ routeprop getpropstr " " strcat .tell
  "Type a single space to keep this, a '.' to abort, or a list of dbrefs seperated with spaces." .tell
  READ
  dup "." stringcmp not if "Setup aborted." .tell exit then
  dup " " stringcmp if
  repairlist
  subwaycar @ swap routeprop swap 0 addprop
  then
  "Message broadcasted in train before train stops:" .tell
  subwaycar @ A_warning getpropstr " " strcat .tell
  "Type a single space to keep this, a '.' to abort, or a new message." .tell
  READ
  dup "." stringcmp not if "Setup aborted." .tell exit then
  dup " " stringcmp if
  subwaycar @ swap A_Warning swap 0 addprop
  then
  "Message broadcasted in train when train has stopped:" .tell
  subwaycar @ A_stop getpropstr " " strcat .tell
  "Type a single space to keep this, a '.' to abort, or a new message." .tell
  READ
  dup "." stringcmp not if "Setup aborted." .tell exit then
  dup " " stringcmp if
  subwaycar @ swap A_Stop swap 0 addprop
  then
  "Message broadcasted in train before train starts:" .tell
  subwaycar @ D_warning getpropstr " " strcat .tell
  "Type a single space to keep this, a '.' to abort, or a new message." .tell
  READ
  dup "." stringcmp not if "Setup aborted." .tell exit then
  dup " " stringcmp if
  subwaycar @ swap D_Warning swap 0 addprop
  then
  "Message broadcasted in train when train starts:" .tell
  subwaycar @ D_Start getpropstr " " strcat .tell
  "Type a single space to keep this, a '.' to abort, or a new message." .tell
  READ
  dup "." stringcmp not if "Setup aborted." .tell exit then
  dup " " stringcmp if
  subwaycar @ swap D_Start swap 0 addprop
  then
  "Train will 'drive' this long in seconds:" .tell
  subwaycar @ Drivedelay getpropstr " " strcat .tell
  "Type a single space to keep this, a '.' to abort, or a new delay in seconds." .tell
  READ
  dup "." stringcmp not if "Setup aborted." .tell exit then
  dup " " stringcmp if
  subwaycar @ swap Drivedelay swap 0 addprop
  then
  "Train will wait this long at stations in seconds:" .tell
  subwaycar @ Stopdelay getpropstr " " strcat .tell
  "Type a single space to keep this, a '.' to abort, or a new delay in seconds." .tell
  READ
  dup "." stringcmp not if "Setup aborted." .tell exit then
  dup " " stringcmp if
  subwaycar @ swap Stopdelay swap 0 addprop
  then
  "The exit leading from the train to the station is named:" .tell
  subwaycar @ exitname getpropstr " " strcat .tell
  "Type a single space to keep this, a '.' to abort, or a new name." .tell
  READ
  dup "." stringcmp not if "Setup aborted." .tell exit then
  dup " " stringcmp if
  subwaycar @ swap exitname swap 0 addprop
  then
  "When a player tries to exit the driving vehicle, this fail-message is displayed:" .tell
  subwaycar @ exitfail getpropstr " " strcat .tell
  "Type a single space to keep this, a '.' to abort, or a new message." .tell
  READ
  dup "." stringcmp not if "Setup aborted." .tell exit then
  dup " " stringcmp if
  subwaycar @ swap exitfail swap 0 addprop
  then
  "When a player tries to exit the driving vehicle, this fail-message is displayed to the others:" .tell
  subwaycar @ exitofail getpropstr " " strcat .tell
  "Type a single space to keep this, a '.' to abort, or a new message." .tell
  READ
  dup "." stringcmp not if "Setup aborted." .tell exit then
  dup " " stringcmp if
  subwaycar @ swap exitofail swap 0 addprop
  then
  "When a player exits the stopped train, this succ-message is displayed:" .tell
  subwaycar @ exitsucc getpropstr " " strcat .tell
  "Type a single space to keep this, a '.' to abort, or a new message." .tell
  READ
  dup "." stringcmp not if "Setup aborted." .tell exit then
  dup " " stringcmp if
  subwaycar @ swap exitsucc swap 0 addprop
  then
  "When a player exits the stopped train, this osucc-message is displayed to the others:" .tell
  subwaycar @ exitosucc getpropstr " " strcat .tell
  "Type a single space to keep this, a '.' to abort, or a new message." .tell
  READ
  dup "." stringcmp not if "Setup aborted." .tell exit then
  dup " " stringcmp if
  subwaycar @ swap exitosucc swap 0 addprop
  then
  "The arrival will be announced X seconds before train stops:" .tell
  subwaycar @ arrivedelay getpropstr " " strcat .tell
  "Type a single space to keep this, a '.' to abort, or a new delay." .tell
  READ
  dup "." stringcmp not if "Setup aborted." .tell exit then
  dup " " stringcmp if
  subwaycar @ swap arrivedelay swap 0 addprop
  then
  "The departure will be announced X seconds before train starts:" .tell
  subwaycar @ departdelay getpropstr " " strcat .tell
  "Type a single space to keep this, a '.' to abort, or a new delay." .tell
  READ
  dup "." stringcmp not if "Setup aborted." .tell exit then
  dup " " stringcmp if
  subwaycar @ swap departdelay swap 0 addprop
  then
  "DONE." .tell
;
: helpscreen
  title .tell
  " " .tell
  "    #HELP    -    Displays this help screen" .tell
  "    #HELP2   -    Displays the help screen about properties" .tell
  "    #HELP3   -    Additional help; Advanced stuff." .tell
  "    #SETUP   -    Runs the setup; Necessary before first use and to change properties easily" .tell
  "    #START   -    Starts the train" .tell
  "    #STOP    -    Stops the train" .tell
  "    #CHECK   -    Checks if every necessary information is correctly set up" .tell
" " .tell
;
: help2
  title .tell
  " " .tell
  "    There are some optional properties you may set on the stations." .tell
  "    These properties will override the properties made by setup." .tell
  "    The properties are:" .tell 
  " " .tell
  "    _TRAIN/ARRIVE/warning:<msg displayed when train is about to arrive>" .tell
  "    _TRAIN/ARRIVE/stop:<msg displayed when train stops at the station>" .tell
  "    _TRAIN/DEPART/warning:<msg displayed when train is about to leave>" .tell
  "    _TRAIN/DEPART/start:<msg displayed when train leaves the station>" .tell
  "-----------------------------------" .tell
  "The following messages are broadcasted to the STATION:" .tell
  " " .tell
  "    _STATION/ARRIVE/warning:<msg displayed when train is about to arrive>" .tell
  "    _STATION/ARRIVE/stop:<msg displayed when train stops at the station>" .tell
  "    _STATION/DEPART/warning:<msg displayed when train is about to leave>" .tell
  "    _STATION/DEPART/start:<msg displayed when train leaves the station>" .tell
  "    _STATION/TrainEntrance:<dbref# of the exit leading into the train>" .tell
  " " .tell
  "  With these properties, you are able to setup unique messages for every single station." .tell
  " " .tell
;
: help3
  title .tell
  " " .tell
  "    Now to some MPI additions..." .tell
  " " .tell
  "    You can add a line of MPI to the desc of a station, telling the viewer" .tell
  "    if a train is currently ready for boarding." .tell
  "    To do this, you have to add something like this:" .tell
  "    {nl}{if:{locked:me,<#no of exit>},No train waiting.,The train is waiting.}".tell
  " " .tell
  "    Where <#no of exit> is the dbref of the exit leading into the subway, as specified" .tell
  "    in the _STATION/TrainEntrance property." .tell
  " " .tell
  "    As a nice feature, you can add a 'NEXT HALT' screen to your subway." .tell
  "    The dbref of the next halt is stored on the room where the subway-action is located." .tell
  "    It's in the property _TRAIN/nexttarget, and refreshed when the train stops at a station." .tell
  "    Example MPI:" .tell
  "    {nl}Next halt: {name:{prop:_TRAIN/nexttarget,<db# of room with subwayaction>}" .tell
  " " .tell
  "    This will display something like 'Next halt: New York Central'. Kewl, eh?" .tell
  " " .tell
  "    You only need to manually setup 5 properties per station; The arrive and depart messages," .tell
  "    and the _STATION/TrainEntrance property (NOT OPTIONAL!), holding the dbref# of the" .tell
  "    exit leading from the station into the subway, without the '#'." .tell
  " " .tell
  "  Any comments, requests for autographs, questions, spam or threats to: gyroplast@wtal.de" .tell
  "  There is a COMPLETE listing of all used properties available, plus description." .tell
  "  If you need it for whatever reasons, contact me (Gyroplast), and I'll send it by email." .tell
;
: check
  "Checking property validity..." .tell
  subwaycar @ exitlist getpropstr
  " " explode
  1 +
  BEGIN
  1 -
  dup count !
  not if break then
  " Checking validity of the exitlist..."
  swap
  dup "" stringcmp not if pop "FAILED!! The exitlist is not set!" strcat .tell exit then
  atoi dbref
  dup ok? swap room? and not if "FAILED!! One or more rooms in the exitlist are invalid!" strcat .tell exit else "PASSED." strcat .tell then
  count @
  REPEAT
  subwaycar @ speakers getpropstr
  " " explode
  1 +
  BEGIN
  1 -
  dup count !
  not if break then
  " Checking validity of the broadcasting list..."
  swap
  dup "" stringcmp not if pop "FAILED!! The broadcastinglist is not set!" strcat .tell exit then
  atoi dbref
  dup ok? swap room? and not if "FAILED!! One or more rooms in the broadcastinglist are invalid!" strcat .tell exit else "PASSED." strcat .tell then
  count @
  REPEAT
  subwaycar @ routeprop getpropstr
  " " explode
  1 +
  BEGIN
  1 -
  dup count !
  not if break then
  " Checking validity of the route..."
  swap
  dup "" stringcmp not if pop "FAILED!! The route is not set!" strcat .tell exit then
  atoi dbref
  dup ok? swap room? and not if "FAILED!! One or more rooms in the route are invalid!" strcat .tell exit else "PASSED." strcat .tell then
  count @
  REPEAT
  "Checking properties..." .tell
  " Checking vehicle ownership..." me @ exitlist owncheck not if "PASSED." strcat .tell else "FAILED!! You do not own one or more rooms in the exitlist!" strcat .tell exit then
  " Checking station ownership..." me @ routeprop owncheck not if "PASSED." strcat .tell else "FAILED!! You do not own one or more rooms in the stationlist!" strcat .tell exit then
  " Checking speakers ownership..." me @ speakers owncheck not if "PASSED." strcat .tell else "FAILED!! You do not own one or more rooms in the speakerlist!" strcat .tell exit then
  "Checking delays..." .tell
  " Checking drive-delay..." subwaycar @ drivedelay getpropstr not if "WARNING! No delay set, zero will be used!" strcat .tell else "PASSED." strcat .tell then
  " Checking stop-delay..." subwaycar @ stopdelay getpropstr not if "WARNING! No delay set, zero will be used!" strcat .tell else "PASSED." strcat .tell then
  " Checking arrival-warning-delay..." subwaycar @ arrivedelay getpropstr atoi dup not if pop "WARNING! No delay set, zero will be used!" strcat .tell else subwaycar @ drivedelay getpropstr atoi >= not if "PASSED." strcat .tell else "FAILED!! The warning-delay is longer than the drive-delay!" strcat .tell exit then then
  " Checking departure-warning-delay..." subwaycar @ departdelay getpropstr atoi dup not if pop "WARNING! No delay set, zero will be used!" strcat .tell else subwaycar @ stopdelay getpropstr atoi >= not if "PASSED." strcat .tell else "FAILED!! The warning-delay is longer than the stopdelay!" strcat .tell exit then then
  "Checking station exits..." .tell
  subwaycar @ routeprop getpropstr " " explode
  1 +
  BEGIN
  1 - dup count !
  not if break then
  " Checking #" over strcat "(" strcat over atoi dbref name ")..." strcat strcat
  swap
  atoi dbref
  trainentrance getpropstr
  dup "" stringcmp not if pop "FAILED!! Trainentrance property not set!" strcat .tell exit then 
    dup atoi dbref ok? swap atoi dbref exit? and not if "FAILED!! The trainentrance is not valid!" strcat .tell exit else "PASSED." strcat .tell then
  count @
  REPEAT
  "DONE, everything is set up with valid values. Now try to #START the vehicle." .tell
;
: getnexttarget  ( d -- d )
  temp !
  subwaycar @ routeprop getpropstr
  " " explode
  dup 1 = if pop atoi dbref exit then
  BEGIN
  dup not if pop newtarget @ exit then
  swap
  atoi dbref
  temp @ dbcmp if
    dup 2 >= if
    swap atoi dbref newtarget !
    1 -
    else
    pop swaproute
    subwaycar @ routeprop getpropstr " " explode
    continue
    then
  then
  1 -
  REPEAT
;
: makeexits
  temp !
  subwaycar @ exitlist getpropstr
  " " explode
  begin
  dup not if pop break then
  swap
  atoi dbref
  subwaycar @ exitname getpropstr dup not if pop "out;ou;o;leave" then
  newexit
  intostr
  subwaycar @ "_TRAIN/newexits" getpropstr
  " " strcat
  swap strcat
  repairlist
  subwaycar @ swap "_TRAIN/newexits" swap 0 addprop
  1 -
  REPEAT
  subwaycar @ "_TRAIN/newexits" getpropstr
  " " explode
  BEGIN
  dup not if pop exit then
  swap
  atoi dbref temp @ setlink
  1 -
  REPEAT
;
: lockexits
  subwaycar @ "_TRAIN/newexits" getpropstr
  " " explode
  BEGIN
  dup not if pop break then
  swap
  atoi dbref
  dup subwaycar @ exitfail getpropstr dup not if pop "You cannot exit a moving vehicle!" then setfail
  dup subwaycar @ exitofail getpropstr dup not if pop "tries to leave the vehicle, but fails." then setofail
  "me&!me"
  setlockstr
  pop
  1 -
  REPEAT
  dup temp !
  trainentrance getpropstr
  " " explode
  BEGIN
  dup not if pop exit then
  swap
  atoi dbref
  "me&!me"
  setlockstr
  pop
  1 -
  REPEAT
;
: unlockexits
  subwaycar @ "_TRAIN/newexits" getpropstr
  " " explode
  BEGIN
  dup not if pop break then
  swap
  atoi dbref
  dup
  dup
  subwaycar @ exitsucc getpropstr dup not if pop "You leave the vehicle." then setsucc
  subwaycar @ exitosucc getpropstr dup not if pop "leaves the vehicle." then setosucc
  ""
  setlockstr
  pop
  1 -
  REPEAT
  dup temp !
  trainentrance getpropstr
  " " explode
  BEGIN
  dup not if pop exit then
  swap
  atoi dbref
  ""
  setlockstr
  pop
  1 -
  REPEAT
;
: deleteexits
  subwaycar @ "_TRAIN/newexits" getpropstr
  " " explode
  BEGIN
  dup not if pop break then
  swap
  dup not if pop pop break then
  atoi dbref
  recycle
  1 -
  REPEAT
  subwaycar @ "_TRAIN/newexits" "" 0 addprop
;
: show_arrive_warning
  dup
  #-1
  over
  "_STATION/ARRIVE/warning" getpropstr
  notify_except
  temp !
  subwaycar @ speakers getpropstr
  " " explode
  BEGIN
  dup not if pop exit then
  swap
  atoi dbref
  temp @ A_warning getpropstr
  dup not if pop subwaycar @ A_warning getpropstr then
  #-1 swap notify_except
  1 -
  REPEAT
;
: show_arrival
  dup
  #-1
  over
  "_STATION/ARRIVE/stop" getpropstr
  notify_except
  temp !
  subwaycar @ speakers getpropstr
  " " explode
  BEGIN
  dup not if pop exit then
  swap
  atoi dbref
  temp @ A_stop getpropstr
  dup not if pop subwaycar @ A_stop getpropstr then
  #-1 swap notify_except
  1 -
  REPEAT
;
: show_depart_warning
  dup
  #-1
  over
  "_STATION/DEPART/warning" getpropstr
  notify_except
  temp !
  subwaycar @ speakers getpropstr
  " " explode
  BEGIN
  dup not if pop exit then
  swap
  atoi dbref
  temp @ D_warning getpropstr
  dup not if pop subwaycar @ D_warning getpropstr then
  #-1 swap notify_except
  1 -
  REPEAT
;
: show_departure
  dup
  #-1
  over
  "_STATION/DEPART/start" getpropstr
  notify_except
  temp !
  subwaycar @ speakers getpropstr
  " " explode
  BEGIN
  dup not if pop exit then
  swap
  atoi dbref
  temp @ D_start getpropstr
  dup not if pop subwaycar @ D_start getpropstr then
  #-1 swap notify_except
  1 -
  REPEAT
;
: drive
  subwaycar @ "_started" getpropstr
  "yes" strcmp not if "The vehicle is activated already!" .tell exit then
  subwaycar @ "_started" "yes" 0 addprop
  BACKGROUND
  subwaycar @ "_KILLPID" pid intostr 0 addprop
  "Vehicle started." .tell
  subwaycar @ routeprop getpropstr " " explode
  1 - swap
  atoi dbref
  target !
  BEGIN
  dup not if pop target @ break then
  swap
  pop
  1 -
  REPEAT
  BEGIN  
  getnexttarget 
  dup target !  
  makeexits 
  target @
  lockexits
  subwaycar @ drivedelay getpropstr
  atoi subwaycar @ arrivedelay getpropstr atoi - sleep
  target @
  Show_arrive_warning
  subwaycar @ arrivedelay getpropstr atoi sleep
  target @
  unlockexits
  target @
  show_arrival
  target @ getnexttarget intostr "#" swap strcat subwaycar @ swap "_TRAIN/nexttarget" swap 0 addprop
  subwaycar @ stopdelay getpropstr
  atoi subwaycar @ departdelay getpropstr atoi - sleep
  target @
  show_depart_warning
  subwaycar @ departdelay getpropstr atoi sleep
  deleteexits
  target @ show_departure
  target @ lockexits
  target @ 
  REPEAT
;
: stop
  deleteexits
  subwaycar @ "_KILLPID" getpropstr
  atoi
  subwaycar @ "_KILLPID" "" 0 addprop
  dup not if "The vehicle has been halted already!" .tell exit then
  "The vehicle won't follow it's route anymore!" .tell
  subwaycar @ "_started" "no" 0 addprop
  kill
;
: main
  TRIG location subwaycar !
  dup "#help" stringcmp not if helpscreen else
  dup "#help2" stringcmp not if help2 else
  dup "#help3" stringcmp not if help3 else
  dup "#setup" stringcmp not if setup else
  dup "#check" stringcmp not if check else
  dup "#start" stringcmp not if drive else
  dup "#stop" stringcmp not if stop else
  "I don't know this command. Try #HELP." .tell
  then then then then then then then
;

