(
  @stats.muf     by Gyroplast   06/19/00   v1.0a
 
  A frontend to the in-server @stats function to be used by mortals
  who normally cannot see detailed info on a muck, with some additional
  gimmicks.
 
  Setup:
  ------
     1. Make sure the $def's below reflect your wishes. The defaults will
        work, but maybe reveal more info about the muck than you might want.
     2. Create a @stats;@stat;@sta;@st action on #0 and link it to this prog.
     3. Set the program 3, or W if you want to use the #server function.
 
  That's it. Of course this program is intended for global installation;
  If you're not a wiz on the muck you're planning to use this program, forget
  about it right away, alright?
 
  *** check http://www.gyroplast.com for this and many other programs! ***
  *** This program is distributed under the GPL. Porting and mods      ***
  *** are explicitly allowed as long as this header stays intact, and  ***
  *** the result of any modification is distributed under the GPL.     ***
  *** For a detailed description of the DOs and DONTs, read the GPL at ***
  *** http://www.gyroplast.com/help/gpl.txt   --Thank you--            ***
)
$def on 1
$def off 0
( -------  begin of configuration part ------- )
( define what info is supposed to show in the @stats )
$def SHOW_TOTAL on
$def SHOW_ROOMS on
$def SHOW_EXITS on
$def SHOW_THINGS on
$def SHOW_PROGRAMS on
$def SHOW_PLAYERS on
$def SHOW_GARBAGE on
 
$def OLD_STATS on ( allow using inserver @stat function? )
                  ( If you specify 'on' here, you MUST give the program )
                  ( a wizbit, otherwise an M3 will suffice. ) 
 
$def MAX_PREC 6   ( Maximum precision. 6 is max! )
 
( ------- end of configuration. Do not modify. ------- )
 
$define header " MuckStats v1.0a    by Gyroplast  06/19/00" .tell
               "------------------------------------------" .tell
$enddef
 
: pad ( [ s i -- s' ]  -  Pad string s to definite length i )
  swap "                           " strcat swap strcut pop
;
: power  ( [ i i' -- i ]  -  Return i to the power of i' )
  dup 0 < if "Integer must be >= 0!" abort then
  dup not if pop pop 1 exit then
  over -3 rotate
  begin
    dup 1 > while
    1 - swap
    3 pick *
    swap
  repeat
  pop swap pop
;
: pad_zero  ( [ s i -- s' ]  -  prepend i zeros to s )
  dup 0 <= if 
   pop exit
  else
   "000000000000" swap strcut pop
   swap strcat
  then
;
: max_precision  ( [ i -- i' ]  -  Return max available precision 2b used )
  2147483647 swap 100 * /
  intostr strlen
  dup MAX_PREC > if pop MAX_PREC else 1 - then
  
;
: set_point ( [ i s -- s ]  -  set comma in number s, with precision i )
  over not if swap pop exit then
  over over 
  strlen - 1 + pad_zero
  dup strlen 3 rotate - strcut
  "." swap strcat strcat
;
: calc_ratio  ( [ i i' -- s ]  -  Calculate percentual ratio of i and i' )
  over max_precision -3 rotate
  swap 100 *
  3 pick 10 swap power *
  swap /
  intostr
  set_point
;
: showhelp  ( [  --  ]  -  Display help screen )
  " " .tell
  header
  " " .tell
  "   #help     - Summons a fire elemental" .tell
  "   #server   - Use the in-server @stat function" .tell
  " " .tell
;
: serverfunc  ( [ s --  ]  -  Use old inserver function {NEEDS WIZBIT})
  trig name
  trig "VulpixVelox" setname
  me @ "@stats " 4 rotate strcat force
  trig swap setname
;
: show-garbage ( [ d --  ] - Show garbage stats )
  "        Garbage  :  "
  swap stats -8 rotate pop pop pop pop pop pop
  over intostr 9 pad strcat
  #-1 stats -8 rotate pop pop pop pop pop pop
  over intostr 9 pad strcat
  -3 rotate calc_ratio
  "%" strcat strcat .tell
;
: show-players ( [ d --  ] - Show player stats )
  "        Players  :  "
  swap stats pop -7 rotate pop pop pop pop pop
  over intostr 9 pad strcat
  #-1 stats pop -7 rotate pop pop pop pop pop
  over intostr 9 pad strcat
  -3 rotate calc_ratio
  "%" strcat strcat .tell
;
: show-programs ( [ d --  ] - Show program stats )
  "        Programs :  "
  swap stats pop pop -6 rotate pop pop pop pop
  over intostr 9 pad strcat
  #-1 stats pop pop -6 rotate pop pop pop pop
  over intostr 9 pad strcat
  -3 rotate calc_ratio
  "%" strcat strcat .tell
;
: show-things ( [ d --  ] - Show thing stats )
  "        Things   :  "
  swap stats pop pop pop -5 rotate pop pop pop
  over intostr 9 pad strcat
  #-1 stats pop pop pop -5 rotate pop pop pop
  over intostr 9 pad strcat
  -3 rotate calc_ratio
  "%" strcat strcat .tell
;
: show-exits ( [ d --  ] - Show exit stats )
  "        Exits    :  "
  swap stats pop pop pop pop -4 rotate pop pop
  over intostr 9 pad strcat
  #-1 stats pop pop pop pop -4 rotate pop pop
  over intostr 9 pad strcat
  -3 rotate calc_ratio
  "%" strcat strcat .tell
;
: show-rooms ( [ d --  ] - Show room stats )
  "        Rooms    :  "
  swap stats pop pop pop pop pop -3 rotate pop
  over intostr 9 pad strcat
  #-1 stats pop pop pop pop pop -3 rotate pop
  over intostr 9 pad strcat
  -3 rotate calc_ratio
  "%" strcat strcat .tell
;
: show-total ( [ d --  ] - Show total stats )
  "        -----------------------------------------" .tell
  "        TOTAL    :  "
  swap stats pop pop pop pop pop pop swap
  over intostr 9 pad strcat
  #-1 stats pop pop pop pop pop pop swap
  over intostr 9 pad strcat
  -3 rotate calc_ratio
  "%" strcat strcat .tell
;
: showstats  ( [ d --  ]  -  Show complete stats for player d )
  " " .tell
  "        Statistics for " over unparseobj strcat " :" strcat .tell
  "                    Owned    MUCK     %owned" .tell
  dup SHOW_GARBAGE if show-garbage else pop then
  dup SHOW_PLAYERS if show-players else pop then
  dup SHOW_PROGRAMS if show-programs else pop then
  dup SHOW_THINGS if show-things else pop then
  dup SHOW_EXITS if show-exits else pop then
  dup SHOW_ROOMS if show-rooms else pop then
  dup SHOW_TOTAL if show-total then
  pop
  " " .tell
;
: main
  strip
  dup not if pop "me" then
  dup "#h" stringpfx 1 = if pop showhelp exit then
  dup "#s" stringpfx 1 = if 
   OLD_STATS prog "w" flag? and if
    dup " " instr strcut swap 
    dup not if swap then pop
    serverfunc exit 
   else
    "This feature has been disabled by the program owner." .tell exit
   then
  then
  .pmatch
  dup me @ dbcmp me @ "W" flag? or not if
    "Only wizzes are allowed to do that." .tell exit
  then
  dup player? not if
    pop "I do not recognize that player." .tell exit
  then
 
  showstats
;

