( NEXTSAVE.MUF     by Gyroplast   08/16/99  
  Displays the remaining time until next database save
 
  Setup:
    Simply link an action to the program and you're all set.
 
  Optionally you can specify a custom string to be displayed.
  Use the appropriate substitutions, and @set the _custom property
  on yourself accordingly.
  Substitutions are:
     %H -- hour, "00" - "23"        %h -- hour, "0" - "23"
     %M -- minute, "00" - "59"      %m -- minute, "0" - "59"
     %S -- seconds, "00" - "59"     %s -- seconds, "0" - "59"
     
  Ex: 
   @set me=_custom:Time until next save: %R 
  Have phun!
 
  *** check http://www.gyroplast.com for this and many other programs! ***
  *** This program is distributed under the GPL. Porting and mods      ***
  *** are explicitly allowed as long as this header stays intact, and  ***
  *** the result of any modification is distributed under the GPL.     ***
  *** For a detailed description of the DOs and DONTs, read the GPL at ***
  *** http://www.gyroplast.com/help/gpl.txt   --Thank you--            ***
)
$def deftimestr "Next database save will be in %h hours, %m mins and %s seconds."
$def header "NEXTSAVE v1.2   by Gyroplast"
$def line   "----------------------------"
: GetSaveDelta  ( [  -- i ] - deltaT to next save in seconds )
  #0 "_sys/dumpinterval" getpropval
  systime #0 "_sys/lastdumptime" getpropval - -
;
: SplitTime  ( [ i -- ih im is ] - split time up into hours, mins and secs )
  dup 3600 / swap 3600 %
  dup 60 / swap 60 %
;
: SubstAnnounceString  ( [ ih im is -- s ] -- construct announce string )
  me @ "_custom" getpropstr dup not if
   pop deftimestr
  then
  
  over intostr "%s" subst
  swap intostr "0" swap strcat "%S" subst
  over intostr "%m" subst
  swap intostr "0" swap strcat "%M" subst
  over intostr "%h" subst
  swap intostr "0" swap strcat "%H" subst
;
: switch-on  (switch notification on connect ON)
  #0 "_connect/zznextsave" getpropstr not if ( set on fur if not global )
    me @ "_connect/zznextsave" prog intostr 1 addprop
  then
  me @ "_displaynextsave" "yes" 0 addprop
  "Notification on connection switched ON." .tell
;
: switch-off  (switch notification on connect OFF)
  me @ "_connect/zznextsave" remove_prop
  me @ "_displaynextsave" remove_prop
  "Notification on connection switched OFF." .tell
;
: install-global  ( automatically set prop on #0 )
  me @ "W" flag? not if
    "Only wizzes may do that!" .tell
  else
    #0 "_connect/zznextsave" prog intostr 1 addprop
    "nextsave.muf is now globally activated." .tell
  then
;
: remove-global  ( remove global property )
  me @ "W" flag? not if
    "Only wizzes may do that!" .tell
  else
    #0 "_connect/zznextsave" over over
    getpropstr atoi prog intostr atoi = not if
      "The _connect/zznextsave prop on #0 doesnt seem to be calling" .tell
      "this program. Please check that manually." .tell
      pop pop
    else
      remove_prop
      "nextsave.muf is now globally deactivated!" .tell
    then
  then
;
: showsubsthelp
  header .tell
  line .tell
  " " .tell
  "  To use a custom announce string, you have to set the _custom" .tell
 "  property on yourself. Include one or more of the substitutions below" .tell
  "  to make the string look as expected." .tell
  "  To reset the default, simply delete the property again with" .tell
  "     @set me=_custom:" .tell
  " " .tell
  "  Substitutions are:" .tell
  "    %H -- hour, \"00\" - \"23\"        %h -- hour, \"0\" - \"23\"" .tell
  "    %M -- minute, \"00\" - \"59\"      %m -- minute, \"0\" - \"59\"" .tell
  "    %S -- seconds, \"00\" - \"59\"     %s -- seconds, \"0\" - \"59\"" .tell
  " " .tell
  "  Example:" .tell
  "  To see a string like " .tell
  "  \"Next save will be in 3 hours, 12 mins and 2 seconds.\"," .tell
  "  you'd have to type" .tell
  "    @set me=_custom:Next save will be in %h hours, %m mins and %s seconds." .tell
  " " .tell
;
: showhelp  (Wha? User needs help? No problem.)
  header .tell
  line .tell
  " " .tell
  "   Parameters" .tell
  "      #ON     : Be notified of remaining time when you connect" .tell
  "      #OFF    : Switch connection notification off" .tell
  "      #GLOBAL : Activate notification for everyone (wiz only)" .tell
  "      #HELP   : Declares WorldWar 3" .tell
  "      #SUB    : Show available substitution strings" .tell
  " " .tell
  "  You can set a custom announce string for yourself by typing" .tell
  "   @set me=_custom:<custom string>" .tell
  " " .tell
  "  For more help on setting a custom string, see " command @ strcat
  " #SUB" strcat .tell 
;
: main
  dup "#h" stringpfx 1 = if
   pop showhelp exit
  then
  dup "#s" stringpfx 1 = if
   pop showsubsthelp exit
  then
  dup "#g" stringpfx 1 = if
   pop install-global exit
  then
  dup "#!g" stringpfx 1 = if
   pop remove-global exit
  then
  dup "#on" stringpfx 1 = if
   pop switch-on exit
  then
  dup "#of" stringpfx 1 = if
   pop switch-off exit
  then
  dup "Connect" strcmp not if
    me @ "_displaynextsave" getpropstr 
    "yes" strcmp if exit then
  then
  
  GetSaveDelta
  SplitTime
  SubstAnnounceString
  .tell
;

